_batchSkinwrapSources = #()
_batchSkinwrapTargets = #()

rollout BatchSkinwrap_UI "Batch Skinwrap" (
	button btnNoSkin "Decimate Skin"
	button btnNoSkinwrap "Decimate Skinwrap"
	button btnSetSource "Mark As Source"
	button btnSetTarget "Mark As Target"
	button btnReset "Reset Marks"
	button btnSkinwrap "Skinwrap"
	edittext txtFalloff "Falloff:" text:"1.0"
	edittext txtThreshold "Threshold:" text:"5.0"
	
	on btnNoSkin pressed do (
		skinwrapMeshes = selection

		count = 0
		for obj in skinwrapMeshes do (
			if obj.modifiers[#skin] != undefined then (
				count = count + 1
				deleteModifier obj obj.modifiers[#skin]
			)
		)
		
		MessageBox ("Deleted the Skin modifier of " + (count as string) + " objects.") beep:false
	)
	
	on btnNoSkinwrap pressed do (
		skinwrapMeshes = selection
		
		count = 0

		for obj in skinwrapMeshes do (
			if obj.modifiers[#skinwrap] != undefined then (
				count = count + 1
				deleteModifier obj obj.modifiers[#skinwrap]
			)
		)
		
		MessageBox ("Deleted the Skinwrap modifier of " + (count as string) + " objects.") beep:false
	)
	
	on btnSetSource pressed do (
		for obj in GetCurrentSelection() do (
			append _batchSkinwrapSources obj
		)
		
		MessageBox ("Marked " + (selection.count as String) + " objects as source.") beep:false
	)
	
	on btnSetTarget pressed do (
		for obj in GetCurrentSelection() do (
			append _batchSkinwrapTargets obj
		)
		
		MessageBox ("Marked " + (selection.count as String) + " objects as target.") beep:false	
	)
	
	on btnReset pressed do (
		_batchSkinwrapTargets = #()
		_batchSkinwrapSources = #()
		
		MessageBox "Reset all marks." beep:false
	)
	
	on btnSkinwrap pressed do (		
		for obj in _batchSkinwrapTargets do (
			print ("skinwrapping " + obj.name)
			
			skinwrap = Skin_Wrap()
			skinwrap.engine = 0 -- Face deformation
			skinwrap.weightAllVerts = true
			skinwrap.meshList = _batchSkinwrapSources
			skinwrap.falloff = (txtFalloff.text as float)
			skinwrap.threshold = (txtThreshold.text as float)
			
			addModifier obj skinwrap
		)		
	)
)

createDialog BatchSkinwrap_UI