function SmoothMesh o = (
	if classof o == Editable_Mesh then (
		print ("Smooth " + (o as string) + " mesh")
		
		numfaces = meshop.getNumFaces o
		faces = (for i in 1 to numfaces collect i) as bitarray
		meshop.autosmooth o faces 360.0 -- Meshop doesn't have explicit smoothing-group setting, but this should do the same thing.
	)
	
	if classof o == Editable_Poly or classof o == PolyMeshObject then (
		print ("Smooth " + (o as string) + " poly")
		
		numfaces = polyop.getNumFaces o
		faces = (for i in 1 to numfaces collect i) as bitarray
		polyop.setFaceSmoothGroup o faces 1
	)
)

function ResetNormals o = (
	if classof o == Editable_Mesh or classof o == Editable_Poly or classof o == PolyMeshObject then (
		print ("Reset " + (o as string))
		
		nrms = Edit_Normals()
		
		addModifier o nrms
		
		numnormals = nrms.getNumNormals node:o
		
		-- Reset explicit
		for i in 1 to numnormals do (
			nrms.SetNormalExplicit i explicit:false node:o
		)
		
		-- And then sometimes they go to specified, so reset specified
		numfaces = nrms.getNumFaces node:o
		for f in 1 to numfaces do (
			numcorners = nrms.getFaceDegree f node:o
			
			for c in 1 to numcorners do (
				nrms.SetFaceNormalSpecified f c specified:false node:o
			)
		)
		
		maxOps.CollapseNodeTo o 1 true
	)
)

function SmoothReset = (
	for o in geometry do (
		select o
		
		SmoothMesh o
		ResetNormals o
		
		deselect o
	)
)

SmoothReset()