rollout JiggleCopy_UI "Bone Jiggler" width:220 (
	button btnJiggle "Jiggle Bones"
	button btnJiggleNoRoot "Jiggle Bones w/o Roots"
	
	on btnJiggle pressed do (
		undo on (
			cnt = 0
			rootcnt = 0
			
			-- Note that this will transform a chain of bones from "BoneA -> BoneB -> BoneC" to "BoneA_jiggle_root -> BoneA_jiggle -> BoneA -> BoneB_jiggle -> BoneB -> BoneC_jiggle -> BoneC"
			-- Create the root jiggles, but only for the parent-most bones
			selarray = Selection as array
			for b in Selection do (
				if classof b == BoneGeometry or classof b == Dummy then (
					if finditem selarray b.parent == 0 then (
						nb = BoneSys.CreateBone b.transform.row4 (b.pos + b.transform.row1*b.length) [0,0,1] -- This is code I found online for making a bone. Don't ask me what exactly it does.
						nb.name = b.name + "_jiggle_root"
						nb.rotation = b.rotation
						nb.pos = b.pos
						
						nb.parent = b.parent
						b.parent = nb
					
						rootcnt = rootcnt + 1
					)
				)
			)
			
			-- Create all the jiggle bones
			for b in Selection do (
				if classof b == BoneGeometry or classof b == Dummy then (
					nb = BoneSys.CreateBone b.transform.row4 (b.pos + b.transform.row1*b.length) [0,0,1]
					nb.name = (b.name + "_jiggle")
					nb.rotation = b.rotation
					nb.pos = b.pos
					
					nb.parent = b.parent
					b.parent = nb
					
					cnt = cnt + 1
				)
			)
		)
		
		MessageBox ("Jiggled " + (cnt as String) + " bones, with " + (rootcnt as String) + " roots.") beep:False
	)
	
	on btnJiggleNoRoot pressed do (
		undo on (
			cnt = 0
			rootcnt = 0
			
			-- Create the root jiggles, but only for the parent-most bones
			selarray = Selection as array
			for b in Selection do (
				if classof b == BoneGeometry or classof b == Dummy then (
					if finditem selarray b.parent == 0 then (				
						rootcnt = rootcnt + 1
					)
				)
			)
			
			-- Create all the jiggle bones
			for b in Selection do (
				if classof b == BoneGeometry or classof b == Dummy then (
					nb = BoneSys.CreateBone b.transform.row4 (b.pos + b.transform.row1*b.length) [0,0,1]
					nb.name = (b.name + "_jiggle")
					nb.rotation = b.rotation
					nb.pos = b.pos
					
					nb.parent = b.parent
					b.parent = nb
					
					cnt = cnt + 1
				)
			)
		)
		
		MessageBox ("Jiggled " + (cnt as String) + " bones, with " + (rootcnt as String) + " roots.") beep:False
	)
)

createDialog JiggleCopy_UI