fn SafeLink a b = (
	if a != undefined then (
		if b != undefined then (
			a.parent = b
		)
	)
)

fn GNBN n = ( -- Because sometimes the default getnodebyname doesn't work, for some reason
	lname = toLower n
	
	for o in Geometry do (
		if (stricmp o.name n) == 0 then (
			return o
		)
	)
	
	return undefined
)

-- Bones
fn LinkSkyrimBones = (
local pelvis = GNBN "NPC Pelvis [Pelv]"
local spn0 = GNBN "NPC Spine [Spn0]"
local spn1 = GNBN "NPC Spine1 [Spn1]"
local spn2 = GNBN "NPC Spine2 [Spn2]"

local lclav = GNBN "NPC L Clavicle [LClv]"
local luarm = GNBN "NPC L UpperArm [LUar]"
local luarmt1 = GNBN "NPC L UpperArmTwist1 [LUt1]"
local luarmt2 = GNBN "NPC L UpperArmTwist2 [LUt2]"
local lfarm = GNBN "NPC L Forearm [LLar]"
local lfarmt1 = GNBN "NPC L ForearmTwist1 [LLt1]"
local lfarmt2 = GNBN "NPC L ForearmTwist2 [LLt2]"
local lhand = GNBN "NPC L Hand [LHnd]"

local lthigh = GNBN "NPC L Thigh [LThg]"
local lcalf = GNBN "NPC L Calf [LClf]"
local lfoot = GNBN "NPC L Foot [LFt ]"
local ltoe = GNBN "NPC L Toe0 [LToe]"

local lf00 = GNBN "NPC L Finger00 [LF00]"
local lf01 = GNBN "NPC L Finger01 [LF01]"
local lf02 = GNBN "NPC L Finger02 [LF02]"
local lf10 = GNBN "NPC L Finger10 [LF10]"
local lf11 = GNBN "NPC L Finger11 [LF11]"
local lf12 = GNBN "NPC L Finger12 [LF12]"
local lf20 = GNBN "NPC L Finger20 [LF20]"
local lf21 = GNBN "NPC L Finger21 [LF21]"
local lf22 = GNBN "NPC L Finger22 [LF22]"
local lf30 = GNBN "NPC L Finger30 [LF30]"
local lf31 = GNBN "NPC L Finger31 [LF31]"
local lf32 = GNBN "NPC L Finger32 [LF32]"
local lf40 = GNBN "NPC L Finger40 [LF40]"
local lf41 = GNBN "NPC L Finger41 [LF41]"
local lf42 = GNBN "NPC L Finger42 [LF42]"

local rclav = GNBN "NPC R Clavicle [RClv]"
local ruarm = GNBN "NPC R UpperArm [RUar]"
local ruarmt1 = GNBN "NPC R UpperArmTwist1 [RUt1]"
local ruarmt2 = GNBN "NPC R UpperArmTwist2 [RUt2]"
local rfarm = GNBN "NPC R Forearm [RLar]"
local rfarmt1 = GNBN "NPC R ForearmTwist1 [RLt1]"
local rfarmt2 = GNBN "NPC R ForearmTwist2 [RLt2]"
local rhand = GNBN "NPC R Hand [RHnd]"

local rthigh = GNBN "NPC R Thigh [RThg]"
local rcalf = GNBN "NPC R Calf [RClf]"
local rfoot = GNBN "NPC R Foot [RFt ]"
local rtoe = GNBN "NPC R Toe0 [RToe]"

local rf00 = GNBN "NPC R Finger00 [RF00]"
local rf01 = GNBN "NPC R Finger01 [RF01]"
local rf02 = GNBN "NPC R Finger02 [RF02]"
local rf10 = GNBN "NPC R Finger10 [RF10]"
local rf11 = GNBN "NPC R Finger11 [RF11]"
local rf12 = GNBN "NPC R Finger12 [RF12]"
local rf20 = GNBN "NPC R Finger20 [RF20]"
local rf21 = GNBN "NPC R Finger21 [RF21]"
local rf22 = GNBN "NPC R Finger22 [RF22]"
local rf30 = GNBN "NPC R Finger30 [RF30]"
local rf31 = GNBN "NPC R Finger31 [RF31]"
local rf32 = GNBN "NPC R Finger32 [RF32]"
local rf40 = GNBN "NPC R Finger40 [RF40]"
local rf41 = GNBN "NPC R Finger41 [RF41]"
local rf42 = GNBN "NPC R Finger42 [RF42]"

-- Links
SafeLink spn0 pelvis
SafeLink spn1 spn0
SafeLink spn2 spn1

SafeLink lclav spn2
SafeLink luarm lclav
SafeLink luarmt1 luarm
SafeLink luarmt2 luarm
SafeLink lfarm luarm
SafeLink lfarmt1 lfarm
SafeLink lfarmt2 lfarm
SafeLink lhand lfarm

SafeLink lthigh pelvis
SafeLink lcalf lthigh
SafeLink lfoot lcalf
SafeLink ltoe lfoot

SafeLink lf00 lhand
SafeLink lf01 lf00
SafeLink lf02 lf01
SafeLink lf10 lhand
SafeLink lf11 lf10
SafeLink lf12 lf11
SafeLink lf20 lhand
SafeLink lf21 lf20
SafeLink lf22 lf21
SafeLink lf30 lhand
SafeLink lf31 lf30
SafeLink lf32 lf31
SafeLink lf40 lhand
SafeLink lf41 lf40
SafeLink lf42 lf41

SafeLink rf00 rhand
SafeLink rf01 rf00
SafeLink rf02 rf01
SafeLink rf10 rhand
SafeLink rf11 rf10
SafeLink rf12 rf11
SafeLink rf20 rhand
SafeLink rf21 rf20
SafeLink rf22 rf21
SafeLink rf30 rhand
SafeLink rf31 rf30
SafeLink rf32 rf31
SafeLink rf40 rhand
SafeLink rf41 rf40
SafeLink rf42 rf41

SafeLink rclav spn2
SafeLink ruarm rclav
SafeLink ruarmt1 ruarm
SafeLink ruarmt2 ruarm
SafeLink rfarm ruarm
SafeLink rfarmt1 rfarm
SafeLink rfarmt2 rfarm
SafeLink rhand rfarm

SafeLink rthigh pelvis
SafeLink rcalf rthigh
SafeLink rfoot rcalf
SafeLink rtoe rfoot
)

LinkSkyrimBones()