Holepuncher_Cylinders = #()

rollout Holepuncher_UI "Hole Puncher" width:176 (
	label lblBoundingBox "Bounding Box:" pos:[8,8]
	pickbutton pbtnBoundingBox "Pick Box..." pos:[8,28] width:160 height:40
	label lblNumBoxes "# Boxes:" pos:[8,72] 
	spinner spnNumBoxes pos:[80,72] width:87 range:[1,100,6] type:#integer
	label lblRadiusRange "Radius Range:" pos:[8,92]
	spinner spnRadiusMin pos:[80,92] width:45 range:[0.001,100,1]
	spinner spnRadiusMax pos:[122,92] width:45 range:[0.001,100,5]
	label lblHeightRange "Height Range:" pos:[8,112] 
	spinner spnHeightMin pos:[80,112] width:45 range:[-100,100,1]
	spinner spnHeightMax pos:[122,112] width:45 range:[-100,100,5]
	label lblSquashRange "Scale Range:" pos:[8,132]
	spinner spnSquashMin pos:[80,132] width:45 range:[0.001,100,0.25]
	spinner spnSquashMax pos:[122,132] width:45 range:[0.001,100,0.75]
	label lblRotationAxis "Axis of Rotation:" pos:[9,152]
	checkbutton btnX "X" pos:[100, 152] width:16 height:16
	checkbutton btnY "Y" pos:[120, 152] width:16 height:16
	checkbutton btnZ "Z" pos:[140, 152] width:16 height:16
	button btnGenerate "Generate" pos:[8,172] width:160 height:40 enabled:false
	pickbutton pbtnPunch "Punch Through..." pos:[8,220] width:160 height:40 enabled:false
	button btnNew "New Pick" pos:[8,268] width:160 height:25 enabled:false
	
	on pbtnBoundingBox picked obj do (
		if classof obj == Box then (
			pbtnBoundingBox.text = obj.name
			pbtnBoundingBox.enabled = false
			
			btnGenerate.enabled = (not pbtnBoundingBox.enabled) and (btnX.checked or btnY.checked or btnZ.checked)
			btnNew.enabled = true
		) else (
			messagebox "Selection must be a Box object."
		)
	)
	
	on btnX changed ischecked do (
		if ischecked then (
			btnY.checked = false
			btnZ.checked = false
		)
		
		btnGenerate.enabled = (not pbtnBoundingBox.enabled) and (btnX.checked or btnY.checked or btnZ.checked)
	)
	
	on btnY changed ischecked do (
		if ischecked then (
			btnX.checked = false
			btnZ.checked = false
		)
		
		btnGenerate.enabled = (not pbtnBoundingBox.enabled) and (btnX.checked or btnY.checked or btnZ.checked)
	)

	on btnZ changed ischecked do (
		if ischecked then (
			btnY.checked = false
			btnX.checked = false
		)
		
		btnGenerate.enabled = (not pbtnBoundingBox.enabled) and (btnX.checked or btnY.checked or btnZ.checked)
	)

	on btnNew pressed do (
		btnX.checked = false
		btnY.checked = false
		btnZ.checked = false
		btnGenerate.enabled = false
		pbtnBoundingBox.text = "Pick Box..."
		pbtnBoundingBox.enabled = true
		pbtnPunch.enabled = false

		bdnBoxObj = pbtnBoundingBox.object
		masterCyl = Holepuncher_Cylinders[1]
		
		if bdnBoxObj != undefined and isValidNode bdnBoxObj then (
			bdnBoxObj.ishidden = false
		)
		
		if masterCyl != undefined and isValidNode masterCyl then (
			masterCyl.xray = false
		)
	
		pbtnBoundingBox.object = undefined
		Holepuncher_Cylinders = #()
		
		btnNew.enabled = false
	)
	
	on btnGenerate pressed do (
		-- Get the values necessary
		bdnBoxObj = pbtnBoundingBox.object
		
		numBoxes = spnNumBoxes.value
		
		radiusRange = [spnRadiusMin.value,spnRadiusMax.value]
		heightRange = [spnHeightMin.value,spnHeightMax.value]
		squashRange = [spnSquashMin.value,spnSquashMax.value]
		
		posRangeX = [bdnBoxObj.min.x,bdnBoxObj.max.x]
		posRangeY = [bdnBoxObj.min.y,bdnBoxObj.max.y]
		posRangeZ = [bdnBoxObj.min.z,bdnBoxObj.max.z]
		
		-- Determination rotation axis and amount
-- 		rotationQuat = (quat 0 0 1 1)
-- 		if btnY.checked then (
-- 			rotationQuat = (quat 0 1 0 1)
-- 		)
-- 		if btnX.checked then (
-- 			rotationQuat = (quat 1 0 0 1)
-- 		)
-- 		rotationQuat.w = random -1.0 1.0

		rotationAngs = EulerAngles 0 0 0
		if btnX.checked then (
			rotationAngs = EulerToQuat(EulerAngles 0 -90 0) -- For X, first have it rotate so that its length is along the X-axis
		)
		if btnY.checked then (
			rotationAngs = EulerToQuat(EulerAngles -90 0 0) -- For Y, first have it rotate so that its length is along the Y-axis
		)
		if btnZ.checked then (
			rotationAngs = EulerToQuat(EulerAngles 0 0 -90) -- For Z, first have it rotate so that its length is along the Z-axis
		)
		
		-- Delete the previously-generated cylinders
		for o in Holepuncher_Cylinders do (
			if isValidNode o then (
				delete o
			)
		)
		
		Holepuncher_Cylinders = #()
		
		undo on (
			-- Generate the new cylinders
			for i=1 to numBoxes do (
				-- Generate the random rotation
				rotationVariance = random -180 180
				rotationAngs = rotationAngs + EulerToQuat(EulerAngles 0 0 rotationVariance) -- And then have it rotation along its axis
				
				cyl = Cylinder()
				
				cyl.height = random heightRange[1] heightRange[2]
				cyl.radius = random radiusRange[1] radiusRange[2]
				
				cyl.scale = [random squashRange[1] squashRange[2], random squashRange[1] squashRange[2], 1]
				
				-- cyl.rotation = rotationQuat
				
				cyl.rotation = rotationAngs
				cyl.position = [random posRangeX[1] posRangeX[2], random posRangeY[1] posRangeY[2], random posRangeZ[1] posRangeZ[2]]

-- 				tMat = cyl.transform
-- 				prerotate tmat (eulerToQuat rotationAngs)
-- 				cyl.transform = tMat
				
				append Holepuncher_Cylinders cyl
			)
			
			-- Combine all of the cylinders generated into a single mesh
			converttopoly Holepuncher_Cylinders
			
			masterCyl = Holepuncher_Cylinders[1]
			
			for i in 2 to Holepuncher_Cylinders.count do (
				polyop.attach masterCyl Holepuncher_Cylinders[i]
			)
			
			Holepuncher_Cylinders = #(masterCyl)

			-- Hide the box
			bdnBoxObj.ishidden = true
			masterCyl.xray = true
		)
		
		-- Enable the punch-through button
		pbtnPunch.enabled = true
	)
	
	on pbtnPunch picked obj do (
		masterCyl = Holepuncher_Cylinders[1]
		
		print masterCyl
		
		if (masterCyl != undefined and (isValidNode masterCyl)) then (
			undo on (
				obj - masterCyl
				
				Holepuncher_Cylinders = #() -- And then empty this, once the holes have been punched, so a new box can be picked and it won't remove the previously made one.
			)
		)
	)
)

createDialog Holepuncher_UI