if LinkSaver_Array == undefined then (
	global LinkSaver_Array = #()
)

function GetLinkData name = (
	for item in LinkSaver_Array do (
		if item[1] == name then (
			return item
		)
	)
	
	return undefined
)

function SaveLink obj = (
	if obj.parent != undefined then (
		data = GetLinkData obj.name
		
		if data == undefined then (
			item = #()
			item[1] = obj.name
			item[2] = obj.parent.name
			
			append LinkSaver_Array item
			
			return true
		)
	)
	
	return false
)

function GetByName name = (
	for o in geometry do (
		if o.name == name then (
			return o
		)
	)
	
	return undefined
)


rollout LinkSaver_UI "Link Saver" (	
	button btnSaveLinks "Save Links"
	button btnApplyLinks "Apply Links"
	button btnForgetLinks "Forget Links"
	
	on btnSaveLinks pressed do (
		cnt = 0
		
		for o in selection do (
			if o.parent != undefined then (
				saved = SaveLink o
				
				if saved then (
					cnt = cnt + 1
				)
			)
		)
		
		MessageBox ("Saved " + (cnt as string) + " links.") beep:false
	)
	
	on btnApplyLinks pressed do (
		cnt = 0
		
		for item in LinkSaver_Array do (
			child = GetByName item[1]
			parent = GetByName item[2]
			
			if child != undefined and parent != undefined then (
				child.parent = parent
				
				cnt = cnt + 1
			)
		)
		
		MessageBox ("Applied " + (cnt as string) + " of " + (LinkSaver_Array.Count as string) + " links.") beep:false
	)
	
	on btnForgetLinks pressed do (
		cnt = LinkSaver_Array.Count
		
		LinkSaver_Array = #()
		
		MessageBox ("Forgot " + (cnt as string) + " links.") beep:false
	)
)

createDialog LinkSaver_UI