global _MorphSaves = #()

function GetMorphsForName oname = (
	for o in _MorphSaves do (
		if o[1] == oname then (
			return o[2]
		)
	)
	
	return undefined
)

function GetMorphValue omorphs mName = (
	for o in omorphs do (
		if o[1] == mName then (
			return o[2]
		)
	)
	
	return undefined
)

function LogT olog txt = (
	itms = olog.items
	
	append itms txt
	
	olog.items = itms
)

function GetMorpher o = ( -- Since morphers that are renamed are not acquired by o.modifiers[#morpher]!
	for m in o.modifiers do (
		if classof m == Morpher then (
			return m
		)
	)
	
	return undefined
)

rollout MorpherSaver_UI "Morpher Save" width:320 (	
	button saveMorphsBtn "Save Morphs"
	button loadMorphsBtn "Load Morphs"
	button clearMorphsBtn "Clear Morphs"
	button zeroMorphsBtn "Zero Morphs"
	listbox outputLog "Output" height:16 width:300 readonly:true
	
	on clearMorphsBtn pressed do (
		_MorphSaves = #()
		LogT outputLog "Cleared saved morphs."
		LogT outputLog "--------"
	)
	
	on saveMorphsBtn pressed do (
		for o in geometry do (
			oMorpher = GetMorpher o
			if oMorpher != undefined then (
				LogT outputLog ("Processing \""+o.name+"\"")
				
				omorphs = GetMorphsForName o.name
				
				if omorphs == undefined then (
					LogT outputLog "Creating entry for morpher."
					omorphs = #()
					append _MorphSaves #(o.name,omorphs)
				)
				
				for i=1 to 100 do (
					mName = WM3_MC_GetName oMorpher i
					
					if mName != "- empty -" then (
						mValue = WM3_MC_GetValue oMorpher i

						append omorphs #(mName,mValue)
						
						LogT outputLog ("Added entry of (\""+mName+"\","+(mValue as string)+")")
					)
				)
			)
		)
		
		LogT outputlog "-----"
	)
	
	on loadMorphsBtn pressed do (
		for o in geometry do (
			oMorpher = GetMorpher o
			
			if o != undefined then (
				oMorphs = GetMorphsForName o.name
				
				if oMorphs != undefined then (
					LogT outputLog ("Loading morphs for \""+o.name+"\"")
					
					for i=1 to 100 do (
						mName = WM3_MC_GetName oMorpher i
						
						mValue = GetMorphValue oMorphs mName
						
						if mValue != undefined then (
							WM3_MC_SetValue oMorpher i mValue
							LogT outputLog ("Set value of \""+mName+"\" to "+(mValue as string))
						)
					)
				)
			)
		)
		
		LogT outputlog "-----"
	)
	
	on zeroMorphsBtn pressed do (
		for o in geometry do (
			oMorpher = GetMorpher o
			
			if o != undefined then (
				oMorphs = GetMorphsForName o.name
				
				if oMorphs != undefined then (
					LogT outputLog ("Loading morphs for \""+o.name+"\"")
					
					for i=1 to 100 do (
						mName = WM3_MC_GetName oMorpher i
						
						if mName != undefined then (
							WM3_MC_SetValue oMorpher i 0.0
							LogT outputLog ("Zeroed morph \""+mName+"\"")
						)
					)
				)
			)
		)
		
		LogT outputlog "-----"
	)
)

createDialog MorpherSaver_UI