
fn SplitMesh selectedObj cloneName = (
	if classof selectedObj == Editable_Mesh then (
		undo on (
			-- Step 1: Clone the selected object
			maxOps.cloneNodes selectedObj actualNodeList:&origObj newNodes:&clonedObj cloneType:#copy
			
			--ConvertTo clonedObj Editable_Poly
			
			--clonedFaceSelection = polyop.getFaceSelection clonedObj[1]
			clonedFaceSelection = -(getFaceSelection clonedObj[1])
			origFaceSelection = getFaceSelection origObj[1]
			
			-- Step 2: Delete the inverse of the selected vertices on the clone
			--setFaceSelection clonedObj -(getFaceSelection clonedObj)
			meshOp.DeleteFaces clonedObj[1] clonedFaceSelection delIsoVerts:true
			
			-- Step 3: Delete the selected vertices on the original
			meshOp.DeleteFaces origObj[1] origFaceSelection delIsoVerts:true
			
			-- Step 4: Rename the clone
			clonedObj.name = cloneName
			
			-- Step 5: Give the clone a new color
			clonedObj.wirecolor = color (random 0 255) (random 0 255) (random 0 255)
		)
	)
)

rollout MeshSplitter_UI "Mesh Splitter" (
	edittext txtName "New Name"
	button btnSplit "Split" toolTip:"Select the NIF meshes to import"

	on btnSplit pressed do (
		if selection.count == 1 then (
			selectedObj = selection[1]
			
			SplitMesh selectedObj txtName.text
		)
	)
)

utility MeshSplitter_Utility "Mesh Splitter" (
	edittext txtName "New Name:"
	button btnSplit "Split"
	button btnRollout "Launch Rollout"
	
	on btnRollout pressed do (
		createDialog MeshSplitter_UI
	)
	
	on btnSplit pressed do (
		if selection.count == 1 then (
			selectedObj = selection[1]
			
			SplitMesh selectedObj txtName.text
		)
	)
)	